#! /bin/ash
#
# This part of smtp_wrapper is distributed under GNU General Public License.
#
# Sample spam filter script
#   by "Masahiko Ito" <m-ito@myh.no-ip.org>
#
# Thanks to http://www.gabacho-net.jp/anti-spam/anti-spam-system.html
#
# IPФå(S25R)ȥƥĤФå(軰ԥ졼)Ʊ
# ԤΥץȡ`-f'ץ˻ꤹ롣`-if'ץϻꤷʤ
#
#============================================================
#
# ߻ν
#
trap "spam_exit 1 \"kill by signal\"" INT HUP TERM QUIT
#============================================================
#
# ¹ԥѥ
#
PATH="/usr/local/smtp_wrapper:/usr/local/bin:/usr/local/sbin:/usr/bin:/usr/sbin:/bin:/sbin"
export PATH
#============================================================
#
# smtp_wrapperǥ쥯ȥ
#
smtp_wrapper_dir="/usr/local/smtp_wrapper"
#
# ƥݥꥹסǥ쥯ȥ
tmp="/var/tmp"
#
# syslogϻID
sl_ident="smtp_filter"
#
# ۥȤIPǡ١
white_ip_db="${smtp_wrapper_dir}/white_ip_db"
# ۥȤFQDNǡ١
white_hostname_db="${smtp_wrapper_dir}/white_hostname_db"
# ۥȤIPǡ١
black_ip_db="${smtp_wrapper_dir}/black_ip_db"
# ۥȤFQDNǡ١
black_hostname_db="${smtp_wrapper_dir}/black_hostname_db"
#
# ƤΥ졼ĤۥȤIPǡ١
relay_allow_host="${smtp_wrapper_dir}/relay_allow_host_db"
# ΥФ˵Ĥ襢ɥ쥹ǡ١
relay_allow_address="${smtp_wrapper_dir}/relay_allow_address_db"
#============================================================
#
# 
#
cr=`echo -n -e '\r'`; export cr
tab=`echo -n -e '\t'`; export tab
pid="$$"; export pid
#============================================================
#
# spamȽǻ˽λ
#
spam_exit ()
{
    if [ -r ${tmp}/smtp_filter.*.$$.tmp ]
    then
        logger -p mail.info -t ${sl_ident} "[$$]:`cat ${tmp}/smtp_filter.*.$$.tmp | head -50 | egrep -i '^MAIL *FROM:|^RCPT *TO:|^From:|^To:|^Subject:|^Date:'`"
    else
        logger -p mail.info -t ${sl_ident} "[$$]:`cat | head -50 | egrep -i '^MAIL *FROM:|^RCPT *TO:|^From:|^To:|^Subject:|^Date:'`"
    fi
    logger -p mail.info -t ${sl_ident} "[$$]:IP=${from_ip}"
    logger -p mail.info -t ${sl_ident} "[$$]:HOST=${from_hostname}"
    logger -p mail.info -t ${sl_ident} "[$$]:EXIT=$1"
    logger -p mail.info -t ${sl_ident} "[$$]:REASON=$2"
    rm -f ${tmp}/smtp_filter.*.$$.tmp
    echo "[$$]:IP=${from_ip} HOST=${from_hostname} EXIT=$1 REASON=$2"
    exit $1
}
#============================================================
#
# ѥå
#
spam_check ()
{
    if [ "X${from_ip}" = "X" ]
    then
        spam_exit 2 "unknown ip" # *** ۥȤIPȽʤ ***
    fi
#
    for i in `cat ${black_ip_db} |\
    	egrep -v '^#'`
    do
        black_ip=`echo "${from_ip}" |\
    	egrep -i "$i"`
        if [ "X${black_ip}" != "X" ]
        then
            spam_exit 3 "black IP" # *** ۥIPIPǡ١ϿƤ ***
        fi
    done
#
    for i in `cat ${white_ip_db} |\
    	egrep -v '^#'`
    do
        white_ip=`echo "${from_ip}" |\
    	egrep -i "$i"`
        if [ "X${white_ip}" != "X" ]
        then
            break;
        fi
    done
#
    from_hostname=`host ${from_ip} 2>/dev/null |\
    	egrep -i 'domain name pointer' |\
    	head -1 |\
    	sed -e 's/^.* domain name pointer *//;s/\.$//'`
    if [ "X${white_ip}" = "X" -a "X${from_hostname}" = "X" ]
    then
        spam_exit 4 "no dns" # *** ۥȤIPհǤʤ ***
    fi
#
    for i in `cat ${black_hostname_db} |\
    	egrep -v '^#'`
    do
        black_hostname=`echo "${from_hostname}" |\
    	egrep -i "$i"`
        if [ "X${black_hostname}" != "X" ]
        then
            spam_exit 5 "black hostname" # *** ۥ̾ۥ̾ǡ١ϿƤ ***
        fi
    done
#
    for i in `cat ${white_hostname_db} |\
    	egrep -v '^#'`
    do
        white_hostname=`echo "${from_hostname}" |\
    	egrep -i "$i"`
        if [ "X${white_hostname}" != "X" ]
        then
            break;
        fi
    done
#
    if [ "X${white_ip}" = "X" -a "X${white_hostname}" = "X" ]
    then
#
        spam_host=`echo ${from_hostname} |\
        	egrep -i '^[^\.]*[0-9][^0-9\.]+[0-9]'`
        if [ "X${spam_host}" != "X" ]
        then
            spam_exit 6 "rule 1" # *** Υ롼1ϡհFQDNκǲ̡ʺüˤ̾ʳʸʬǤ줿İʾο ***
        fi
#
        spam_host=`echo ${from_hostname} |\
        	egrep -i '^[^\.]*[0-9]{5}'`
        if [ "X${spam_host}" != "X" ]
        then
            spam_exit 7 "rule 2" # *** Υ롼2ϡհFQDNκǲ̤̾5İʾϢ³ޤ ***
        fi
#
        spam_host=`echo ${from_hostname} |\
        	egrep -i '^([^\.]+\.)?[0-9][^\.]*\.[^\.]+\..+\.[a-z]'`
        if [ "X${spam_host}" != "X" ]
        then
            spam_exit 8 "rule 3" # *** Υ롼3ϡհFQDNξ3ؤǲ̤ޤϲ̤2ܤ̾ǻϤޤ ***
        fi
#
        spam_host=`echo ${from_hostname} |\
        	egrep -i '^[^\.]*[0-9]\.[^\.]*[0-9]-[0-9]'`
        if [ "X${spam_host}" != "X" ]
        then
            spam_exit 9 "rule 4" # *** Υ롼4ϡհFQDNκǲ̤̾ǽꡢĲ̤2ܤ̾1ĤΥϥեʬǤ줿İʾοޤ ***
        fi
#
        spam_host=`echo ${from_hostname} |\
        	egrep -i '^[^\.]*[0-9]\.[^\.]*[0-9]\.[^\.]+\..+\.'`
        if [ "X${spam_host}" != "X" ]
        then
            spam_exit 10 "rule 5" # *** Υ롼5ϡհFQDN5ذʾǡ2ؤ̾Ȥ˿ǽ ***
        fi
#
        spam_host=`echo ${from_hostname} |\
        	egrep -i '^(dhcp|dialup|ppp|adsl)[^\.]*[0-9]'`
        if [ "X${spam_host}" != "X" ]
        then
            spam_exit 11 "rule 6" # *** Υ롼6ϡհFQDNκǲ̤̾dhcpסdialupסpppסޤϡadslפǻϤޤꡢĿޤ ***
        fi
    fi
}
#============================================================
#
# 軰ԥ졼å
#
relay_check ()
{
	allow_ip=""
	for i in `cat ${relay_allow_host} |\
		grep -v '^#' |\
		sed -e "s/${tab}/ /g;s/  */ /g" |\
		cut -d ' ' -f 1`
	do
		allow_ip=`echo ${from_ip} |\
			egrep "$i"`
		if [ "X${allow_ip}" != "X" ]
		then
			break
		fi
	done
#
	if [ "X${allow_ip}" = "X" ]
	then
		for i in `cat ${tmp}/smtp_filter.1.$$.tmp |\
			awk 'BEGIN{
				cr = ENVIRON["cr"]
			}
			{
				if (length($0) == 1 && index($0, cr) > 0){
					exit;
				}else{
					print;
				}
			}' |\
			egrep -i '^RCPT *TO:' |\
			sed -e 's/ *//g`
		do
			for j in `cat ${relay_allow_address} |\
				grep -v '^#'`
			do
				allow_rcpt=""
				allow_rcpt=`echo $i |\
					egrep "$j"`
				if [ "X${allow_rcpt}" != "X" ]
				then
					break;
				fi
			done
			if [ "X${allow_rcpt}" = "X" ]
			then
				spam_exit 12 "no relay" # *** 軰ѵ ***
			fi
		done
	fi
}
#============================================================
#
# 
#
from_ip=""
from_hostname=""
white_ip=""
white_hostname=""
black_ip=""
black_hostname=""
#
#============================================================
#
# ľSMTP³ʬΥå
#
# (smtp_wrapper Ķѿ SW_FROM_IP ³IPϤ)
#
from_ip=${SW_FROM_IP}
#
spam_check
#============================================================
#
# ᡼ʸʸ(ס)
#
cat >${tmp}/smtp_filter.1.$$.tmp
#============================================================
#
# 軰ѵ
#
from_ip=${SW_FROM_IP}
#
relay_check
#
#============================================================
#
# ʥ᡼ȽǤ줿ΤϤ
#
export from_ip
export from_hostname
#
cat ${tmp}/smtp_filter.1.$$.tmp |\
awk 'BEGIN{
    from_ip = ENVIRON["from_ip"]
    from_hostname = ENVIRON["from_hostname"]
    pid = ENVIRON["pid"]
    out_sw = 0;
}
{
    if (out_sw == 0){
        head = toupper($0);
        if (head ~ /^DATA\r$/ ||
            head ~ /^DATA$/){
            out_sw = 1;
        }
    }

    if (out_sw == 1){
        print $0;
    }
}
END{
    if (out_sw == 0){
        printf("[%d]:IP=%-s HOST=%-s REASON=NOT spam, but NO DATA\n", pid, from_ip, from_hostname)
    }
}'
#
#============================================================
#
# ƽλ
#
rm -f ${tmp}/smtp_filter.*.$$.tmp
exit 0
